# <span style="color: #89CFF0;">__x__</span>nano

___extremely nano tools for building llm workflows; made for regular people.___

`xnano` is a complete <span style="color: var(--md-code-hl-variable-color);">___batteries-included___</span> library with an aim to provide the most simple, intuitive & flexible interface for building complex llm workflows and applications.


## API & Usage Reference


Use one of the following links to get started with using `xnano`:

<div class="grid cards" markdown>

-   :material-lightning-bolt-circle:{ .lg .middle } __LLM Completions__

    ---

    Generate [`LLM Completions`](#) with <span style="color: var(--md-code-hl-variable-color);">_structured outputs_</span>, <span style="color: var(--md-code-hl-variable-color);">_tool calling & automatic execution_</span>, <span style="color: var(--md-code-hl-variable-color);">_automatically generated tools_</span>, <span style="color: var(--md-code-hl-variable-color);">_RAG with vector stores_</span>, <span style="color: var(--md-code-hl-variable-color);">_streaming_</span>, <span style="color: var(--md-code-hl-variable-color);">_async_</span>, _and more_; all through a ___single function!___.

    [:octicons-arrow-right-24: LLM Completions](#)

-   :material-atom:{ .lg .middle } __A new way to build LLM Agents__

    ---

    Build [`LLM Agents`](#) with [`xnano`](#) simplicity, capable of _multi-agent collaboration_, _auto-generative workflows_, _strict step-oriented workflows_, _and more!_

    [:octicons-arrow-right-24: Agents](#)

-   :material-database-arrow-up-outline:{ .lg .middle } __LLM-Powered Pydantic  Models__

    ---

    Directly generate, edit, and use [`Pydantic Models`](#) as context, directly with features such as <span style="color: var(--md-code-hl-variable-color);">_sequential field generation_</span>, to achieve chain-of-thought reasoning; batch generations & distillation for <span style="color: var(--md-code-hl-variable-color);">_synthetic data_</span>, _and more!_

    [:octicons-arrow-right-24: LLM-Powered Pydantic Models](#)

-   :material-data-matrix:{ .lg .middle } __Vector Stores, NLP & Data Processing__

    ---

    Perform ___NLP___ tasks, create [`LLM-Powered`](#) ___Vector Stores___, and ___Databases___, as well as ___data / web processing___ tasks, with incredibly easy functions; that integrate straight into the rest of the library!

    [:octicons-arrow-right-24: Vector Stores, NLP & Data Processing](#)

</div>

## Applications

Use one of the following links to view examples of `xnano` to build implementations of popular `LLM` & `AI` applications.

